<?= $element->renderSubmenu('/6-lekce-php-a-web'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>V této lekci si ukážeme jak nám může PHP pomoci při vytváření webu.</p>

<p>A jak si pomocí témat níže můžeme postavit jednoduchý web se mlžete podívat <a href="<?= $wwwDir; ?>/files/PHPaWeb.zip">zde</a>.</p>

<h2 class="mainTitle" id="include">Slučování souborů do jednoho</h2>

<p>
	Jak jsme si řekli, <b>PHP</b> se využívá především k tvorbě webových aplikací a webů obecně.
	Určitě jste si všimli, že web se skládá z více stránek. A dokonce každá stránka se skládá z více částí.
	Například hlavička, obsah, patička. A každá tato stránka/část může být samostatný soubor.
	No a pokud chceme spojit více souborů do jednoho, můžeme použít následující funkce.
</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">include</span> <span class="php__str">'soubor'</span>;
    <span class="php__syntax">require</span> <span class="php__str">'soubor'</span>;
    <span class="php__syntax">include_once</span> <span class="php__str">'soubor'</span>;
    <span class="php__syntax">require_once</span> <span class="php__str">'soubor'</span>;
?&gt;
</pre>

<p>
	<a href="https://www.php.net/manual/en/function.include.php" target="_blank">include</a> - tento příkaz vloží soubor. Pokud soubor neexistuje, zobrazí se varování, ale program pokračuje dále.<br>
	<a href="https://www.php.net/manual/en/function.require.php" target="_blank">require</a> - tento příkaz vloží soubor. Pokud soubor neexistuje, zobrazí se chyba a program se zastaví ("spadne").
</p>

<p>
	Příkazy s <b class="text-pink-dark">once</b> na konci dělají to samé. Jediný rozdíl je v tom, že pokud se pokusíme vložit stejný soubor níže, tak se nám to nepovede (nevloží se). Slovíčko <b>once</b> totiž znamená "jednou".
</p>

<p>
	Ale jak jsme si říkali, chyby (a i varování) bychom měli řešit. Proto je případně vhodné někdy otestovat, zda daný soubor existuje.
	To je velmi jednoduché a v PHP na to máme funkci <a href="https://www.php.net/manual/en/function.file-exists.php" target="_blank">file_exists</a>. Pokud soubor existuje, vrátí <b>TRUE</b>, jinak <b>FALSE</b>.
</p>

<pre class="php">
&lt;?php
    <span class="php__var">$soubor</span> = <span class="php__str">"soubor"</span>;
    <span class="php__syntax">if</span> (<span class="php__fun">file_exists</span>(<span class="php__var">$soubor</span>)) {
        <span class="php__syntax">include_once</span> <span class="php__var">$soubor</span>;
    }
?&gt;
</pre>


<h2 class="mainTitle" id="cesty">Cesty</h2>

<p>
	K tomu abychom mohli vkládat soubory pomocí <a href="#include">include/require</a>, musíme znát umístění tohoto souboru, absolutní cestu (celou) k souboru cestu k souboru.
	K tomu využijeme <a href="https://www.php.net/manual/en/language.constants.predefined.php" target="_blank">"magickou" konstantu</a> <b class="text-pink-dark">__DIR__</b>. Ta v sobě nese informaci o cestě k souboru, ve kterém tuto konstantu použijeme.
</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> <span class="php__obj">__DIR__</span>; <span class="php__comment">// vypíše celou cestu k souboru, ve kterém tuto konstantu použijeme</span>
?&gt;
</pre>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Jak jsme si řekli, vždy se ve složce hledá soubor index.php.
		Proto je nejlepší si tuto hodnotu (__DIR__) vložit do proměnné, kterou vytvoříme právě v tomto souboru (index.php).
	</p>
</div>

<p>Ve skutečnosti existují relativní a absolutní cesty. Magická konstanta __DIR__ obsahuje absolutní cestu.</p>

<p>Pokud napíšeme pouze <code>include 'soubor';</code> tak v tomto případě se jedná o relativní cestu. A soubor se bude hledat ve stejné složce, ve které se nachází soubor ve kterém voláme tuto funkci <code>include 'soubor';</code>.</p>

<p>Pokud bychom chtěli hledat o složku výše, napíšeme <code>../</code>, tedy <code>include '../soubor';</code></p>

<h2 class="mainTitle" id="konstanty">Konstanty</h2>

<p>
	Takže cestu k souboru máme uloženou v proměnné. Ale jak zabezpečit, aby jsme si ji nepřesali někde v programu níže.
	K tomu se ideálně hodí konstanty. Ve chvíli, kdy vytvoříte konstantu, tak její hodnotu nemůžete změnit. Pokud se o to pokusíte, program Vám ukáže varovnou hlášku.
</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">define</span>(<span class="php__str">'ROOT_PATH'</span>, <span class="php__obj">__DIR__</span>); <span class="php__comment">// definice pro uložení cesty ke složce, kde je tento web</span>

    <span class="php__comment">// kód níže otestuje, zda daná konstanta již existuje (vrací TRUE, FALSE). A pokud ano, tak její hodnotu vypíše</span>
    <span class="php__syntax">if</span> (<span class="php__fun">defined</span>(<span class="php__str">'ROOT_PATH'</span>)) {
        <span class="php__syntax">echo</span> <span class="php__num">ROOT_PATH</span>;
    }
?&gt;
</pre>

<p>
	Vytvoření konstanty provedeme pomocí klíčového slovíčka <b class="text-pink-dark">define</b>. Jako standard se ujalo psát konstanty <b>velkými písmeny</b>. Není to ale podmínka, přesto to doporučuji.
	Co je ale důležité dodržovat, je velikost písmen. Pokud vše napíšete malými, při použití musíte opět použít jenom malé písmena. Název konstanty je totiž <b>citlivý na velikost písmen</b>.
	Jak si můžete všimnout, tak samotné použití konstanty je poté <b>bez dolaru</b> před jejím názvem.
</p>

<p>V případě, že bychom si chtěli otestovat, zda konstatnta existuje, použijeme funkci <a href="https://www.php.net/manual/en/function.defined.php" target="_blank">defined</a>. Ta vrací <b>TRUE</b> pokud konstanta existuje, pokud ne vrací <b>FALSE</b>.</p>


<h2 class="mainTitle" id="serverove-promenne">Serverové proměnné</h2>
<p>V PHP máme možnost získat zajimávé informace o našem serveru a také o našem požadavku (stránce kterou si prohlížíme - URL). Tyto informace získáme pomocí systémové proměnné <a href="https://www.php.net/manual/en/reserved.variables.server.php" target="_blank">$_SERVER</a>.</p>


<h2 class="mainTitle" id="testovani-promenne">Testování proměnné</h2>

<p>Tak jako můžeme otestovat zda existují konstanty, můžeme otestovat i <b>proměnné</b>. Máme 2 možnosti - <b>isset</b> a <b>empty</b>.</p>

<p><a href="https://www.php.net/manual/en/function.isset.php" target="_blank">isset</a> - otestuje zda proměnná existuje. Pokud proměnná existuje, vrátí <b>TRUE</b>, jinak vrátí <b>FALSE</b>.</p>
<p>
	<a href="https://www.php.net/manual/en/function.empty.php" target="_blank">empty</a> - otestuje zda proměnná obsahuje prázdnou hodnotu (více v dokumentaci). Pokud je proměnná prázdná, vrátí <b>TRUE</b>, jinak vrátí <b>FALSE</b>.
	Výhodou tét funkce je, že pokud použijeme proměnnou, která <b>není vytvořena</b> (není nastavena), tak program neskončí chybou. Díky tomu nemusíme testovat, zda proměnná existuje a poté zda je prázdná.
</p>

<pre class="php">
&lt;?php
    <span class="php__comment">// zjistíme, zda je proměnná vytvořena</span>
    <span class="php__syntax">if</span> (<span class="php__fun">isset</span>(<span class="php__var">$promenna</span>)) {
        <span class="php__syntax">echo</span> <span class="php__var">$promenna</span>;
    }

    <span class="php__comment">// zjistíme, zda je proměnná vytvořena a zároveň zda obsahuje nějakou hodnotu</span>
    <span class="php__syntax">if</span> (!<span class="php__fun">empty</span>(<span class="php__var">$promenna</span>)) {
        <span class="php__syntax">echo</span> <span class="php__var">$promenna</span>;
    }
?&gt;
</pre>


<h2 class="mainTitle" id="ternarni-operator">Ternární operátor - tip pro pokročilejší</h2>

<p>Ternární operátor není nic jiného než zkrácená podmínka na jeden řádek.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> (<span class="php__var">$promenna</span> === <span class="php__syntax">TRUE</span> ? <span class="php__str">'je to pravda'</span> : <span class="php__str">'je to lež'</span>);

    <span class="php__comment">// to stejné pomocí klasického if</span>

    <span class="php__syntax">if</span> (<span class="php__var">$promenna</span> === <span class="php__syntax">TRUE</span>) {
        <span class="php__syntax">echo</span> <span class="php__str">'je to pravda'</span>
    } <span class="php__syntax">else</span> {
        <span class="php__syntax">echo</span> <span class="php__str">'je to lež'</span>
    }
?&gt;
</pre>

